Index: trunk/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 42)
+++ trunk/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 56)
@@ -761,13 +923,490 @@
       xConfirmPara( ui != 1 , "Height should be 2^n");
   }
-
-  // SBACRD is supported only for SBAC
-  if ( m_iSymbolMode == 0 )
-  {
-    m_bUseSBACRD = false;
-  }
+  
+  xConfirmPara( m_iWaveFrontSynchro < 0, "WaveFrontSynchro cannot be negative" );
+  xConfirmPara( m_iWaveFrontFlush < 0, "WaveFrontFlush cannot be negative" );
+  xConfirmPara( m_iWaveFrontSubstreams <= 0, "WaveFrontSubstreams must be positive" );
+  xConfirmPara( m_iWaveFrontSubstreams > 1 && !m_iWaveFrontSynchro, "Must have WaveFrontSynchro > 0 in order to have WaveFrontSubstreams > 1" );
 
 #undef xConfirmPara
   if (check_failed)
+  {
+    exit(EXIT_FAILURE);
+  }
+
+  xCheckCodingStructureMvc();
+}
+
+Void TAppEncCfg::xCheckCodingStructureMvc()
+{
+  bool check_failed = false; /* abort if there is a fatal configuration problem */
+#define xConfirmPara(a,b) check_failed |= confirmPara(a,b)
+
+  // validate that POC of same frame is identical across multiple views
+  Bool bErrorMvePoc = false;
+  if( m_iNumberOfViews > 1 )
+  {
+    for( Int k = 1; k < m_iNumberOfViews; k++ )
+    {
+      for( Int i = 0; i < MAX_GOP; i++ )
+      {
+        if( m_GOPListsMvc[k][i].m_POC != m_GOPListsMvc[0][i].m_POC )
+        {
+          printf( "\nError: Frame%d_v%d POC %d is not identical to Frame%d POC\n", i, k, m_GOPListsMvc[k][i].m_POC, i );
+          bErrorMvePoc = true;
+        }
+      }
+    }
+  }
+  xConfirmPara( bErrorMvePoc,  "Invalid inter-view POC structure given" );
+
+  // validate that baseview has no inter-view refs 
+  Bool bErrorIvpBase = false;
+  for( Int i = 0; i < MAX_GOP; i++ )
+  {
+    if( m_GOPListsMvc[0][i].m_numInterViewRefPics != 0 )
+    {
+      printf( "\nError: Frame%d inter_view refs not available in view 0\n", i );
+      bErrorIvpBase = true;
+    }
+  }
+  xConfirmPara( bErrorIvpBase, "Inter-view refs not possible in base view" );
+
+  // validate inter-view refs
+  Bool bErrorIvpEnhV = false;
+  if( m_iNumberOfViews > 1 )
+  {
+    for( Int k = 1; k < m_iNumberOfViews; k++ )
+    {
+      for( Int i = 0; i < MAX_GOP+1; i++ )
+      {
+        for( Int j = 0; j < m_GOPListsMvc[k][i].m_numInterViewRefPics; j++ )
+        {
+          Int iAbsViewId = m_GOPListsMvc[k][i].m_interViewRefs[j] + k;
+          if( iAbsViewId < 0 || iAbsViewId >= k )
+          {
+            printf( "\nError: inter-view ref pic %d is not available for Frame%d_v%d\n", m_GOPListsMvc[k][i].m_interViewRefs[j], i, k );
+            bErrorIvpEnhV = true;
+          }
+          if( m_GOPListsMvc[k][i].m_interViewRefPosL0[j] < 0 || m_GOPListsMvc[k][i].m_interViewRefPosL0[j] > m_GOPListsMvc[k][i].m_numRefPicsActive )
+          {
+            printf( "\nError: inter-view ref pos %d on L0 is not available for Frame%d_v%d\n", m_GOPListsMvc[k][i].m_interViewRefPosL0[j], i, k );
+            bErrorIvpEnhV = true;
+          }
+          if( m_GOPListsMvc[k][i].m_interViewRefPosL1[j] < 0 || m_GOPListsMvc[k][i].m_interViewRefPosL1[j] > m_GOPListsMvc[k][i].m_numRefPicsActive )
+          {
+            printf( "\nError: inter-view ref pos %d on L1 is not available for Frame%d_v%d\n", m_GOPListsMvc[k][i].m_interViewRefPosL1[j], i, k );
+            bErrorIvpEnhV = true;
+          }
+        }
+        if( i == MAX_GOP ) // inter-view refs at I pic position in base view
+        {
+          if( m_GOPListsMvc[k][MAX_GOP].m_sliceType != 'B' && m_GOPListsMvc[k][MAX_GOP].m_sliceType != 'P' && m_GOPListsMvc[k][MAX_GOP].m_sliceType != 'I' )
+          {
+            printf( "\nError: slice type of FrameI_v%d must be equal to B or P or I\n", k );
+            bErrorIvpEnhV = true;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_POC != 0 )
+          {
+            printf( "\nError: POC %d not possible for FrameI_v%d, must be 0\n", m_GOPListsMvc[k][MAX_GOP].m_POC, k );
+            bErrorIvpEnhV = true;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_temporalId != 0 )
+          {
+            printf( "\nWarning: Temporal id of FrameI_v%d must be 0 (cp. I-frame in base view)\n", k );
+            m_GOPListsMvc[k][MAX_GOP].m_temporalId = 0;
+          }
+
+          if( !(m_GOPListsMvc[k][MAX_GOP].m_refPic) )
+          {
+            printf( "\nWarning: FrameI_v%d must be ref pic (cp. I-frame in base view)\n", k );
+            m_GOPListsMvc[k][MAX_GOP].m_refPic = true;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_numRefPics != 0 )
+          {
+            printf( "\nWarning: temporal references not possible for FrameI_v%d\n", k );
+            for( Int j = 0; j < m_GOPListsMvc[k][MAX_GOP].m_numRefPics; j++ )
+            {
+              m_GOPListsMvc[k][MAX_GOP].m_referencePics[j] = 0;
+            }
+            m_GOPListsMvc[k][MAX_GOP].m_numRefPics = 0;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_interRPSPrediction )
+          {
+            printf( "\nError: inter RPS prediction not possible for FrameI_v%d, must be 0\n", k );
+            bErrorIvpEnhV = true;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_sliceType == 'I' && m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics != 0 )
+          {
+            printf( "\nError: inter-view prediction not possible for FrameI_v%d with slice type I, #IV_ref_pics must be 0\n", k );
+            bErrorIvpEnhV = true;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_numRefPicsActive > m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics )
+          {
+            m_GOPListsMvc[k][MAX_GOP].m_numRefPicsActive = m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics;
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_sliceType == 'P' )
+          {
+            if( m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics < 1 )
+            {
+              printf( "\nError: #IV_ref_pics must be at least one for FrameI_v%d with slice type P\n", k );
+              bErrorIvpEnhV = true;
+            }
+            else
+            {
+              for( Int j = 0; j < m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics; j++ )
+              {
+                if( m_GOPListsMvc[k][MAX_GOP].m_interViewRefPosL1[j] != 0 )
+                {
+                  printf( "\nError: inter-view ref pos %d on L1 not possible for FrameI_v%d with slice type P\n", m_GOPListsMvc[k][MAX_GOP].m_interViewRefPosL1[j], k );
+                  bErrorIvpEnhV = true;
+                }
+              }
+            }
+          }
+
+          if( m_GOPListsMvc[k][MAX_GOP].m_sliceType == 'B' && m_GOPListsMvc[k][MAX_GOP].m_numInterViewRefPics < 1 )
+          {
+            printf( "\nError: #IV_ref_pics must be at least one for FrameI_v%d with slice type B\n", k );
+            bErrorIvpEnhV = true;
+          }
+        }
+      }
+    }
+  }
+  xConfirmPara( bErrorIvpEnhV, "Invalid inter-view coding structure for enhancement views given" );
+
+  // validate temporal coding structure
+  if( !bErrorMvePoc && !bErrorIvpBase && !bErrorIvpEnhV )
+  {
+    for( Int viewId = 0; viewId < m_iNumberOfViews; viewId++ )
+    {
+      Bool verifiedGOP = false;
+      Bool errorGOP    = false;
+      Int  checkGOP    = 1;
+      Int  numRefs     = 1;
+      Int refList[MAX_NUM_REF_PICS+1];
+      refList[0] = 0;
+      Bool isOK[MAX_GOP];
+      for( Int i = 0; i < MAX_GOP; i++ ) { isOK[i] = false; }
+      Int numOK = 0;
+#if !H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+      Int numReorderFramesRequired=0;
+      m_maxNumberOfReferencePictures=0;
+      Int lastDisp = -1;
+#endif
+      m_extraRPSs[viewId] = 0;
+      //start looping through frames in coding order until we can verify that the GOP structure is correct.
+      while( !verifiedGOP && !errorGOP )
+      {
+        Int curGOP = (checkGOP-1)%m_iGOPSize;
+        Int curPOC = ((checkGOP-1)/m_iGOPSize)*m_iGOPSize + m_GOPListsMvc[viewId][curGOP].m_POC;    
+        if( m_GOPListsMvc[viewId][curGOP].m_POC < 0 )
+        {
+          printf( "\nError: found fewer Reference Picture Sets than GOPSize for view %d\n", viewId );
+          errorGOP = true;
+        }
+        else 
+        {
+          //check that all reference pictures are available, or have a POC < 0 meaning they might be available in the next GOP.
+          Bool beforeI = false;
+          for( Int i = 0; i < m_GOPListsMvc[viewId][curGOP].m_numRefPics; i++ ) 
+          {
+            Int absPOC = curPOC + m_GOPListsMvc[viewId][curGOP].m_referencePics[i];
+            if( absPOC < 0 )
+            {
+              beforeI = true;
+            }
+            else 
+            {
+              Bool found = false;
+              for( Int j = 0; j < numRefs; j++ )
+              {
+                if( refList[j] == absPOC ) 
+                {
+                  found = true;
+                  for( Int k = 0; k < m_iGOPSize; k++ )
+                  {
+                    if( absPOC%m_iGOPSize == m_GOPListsMvc[viewId][k].m_POC%m_iGOPSize )
+                    {
+                      m_GOPListsMvc[viewId][curGOP].m_usedByCurrPic[i] = (m_GOPListsMvc[viewId][k].m_temporalId <= m_GOPListsMvc[viewId][curGOP].m_temporalId);
+                    }
+                  }
+                }
+              }
+              if( !found )
+              {
+                printf("\nError: ref pic %d is not available for GOP frame %d of view %d\n", m_GOPListsMvc[viewId][curGOP].m_referencePics[i], curGOP+1, viewId );
+                errorGOP = true;
+              }
+            }
+          }
+          if( !beforeI && !errorGOP )
+          {
+            //all ref frames were present
+            if( !isOK[curGOP] ) 
+            {
+              numOK++;
+              isOK[curGOP] = true;
+              if( numOK == m_iGOPSize )
+              {
+                verifiedGOP = true;
+              }
+            }
+          }
+          else 
+          {
+            //create a new GOPEntry for this frame containing all the reference pictures that were available (POC > 0)
+            m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]] = m_GOPListsMvc[viewId][curGOP];
+            Int newRefs = 0;
+            for( Int i = 0; i < m_GOPListsMvc[viewId][curGOP].m_numRefPics; i++ )
+            {
+              Int absPOC = curPOC + m_GOPListsMvc[viewId][curGOP].m_referencePics[i];
+              if( absPOC >= 0 )
+              {
+                m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[newRefs] = m_GOPListsMvc[viewId][curGOP].m_referencePics[i];
+                m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_usedByCurrPic[newRefs] = m_GOPListsMvc[viewId][curGOP].m_usedByCurrPic[i];
+                newRefs++;
+              }
+            }
+            Int numPrefRefs = m_GOPListsMvc[viewId][curGOP].m_numRefPicsActive;
+
+            for( Int offset = -1; offset > -checkGOP; offset-- )
+            {
+              //step backwards in coding order and include any extra available pictures we might find useful to replace the ones with POC < 0.
+              Int offGOP =  (checkGOP - 1 + offset)%m_iGOPSize;
+              Int offPOC = ((checkGOP - 1 + offset)/m_iGOPSize) * m_iGOPSize + m_GOPListsMvc[viewId][offGOP].m_POC;
+              if( offPOC >= 0 && m_GOPListsMvc[viewId][offGOP].m_refPic && m_GOPListsMvc[viewId][offGOP].m_temporalId <= m_GOPListsMvc[viewId][curGOP].m_temporalId )
+              {
+                Bool newRef = false;
+                for( Int i = 0; i < numRefs; i++ )
+                {
+                  if( refList[i] == offPOC )
+                  {
+                    newRef = true;
+                  }
+                }
+                for( Int i = 0; i < newRefs; i++ ) 
+                {
+                  if( m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[i] == (offPOC - curPOC) )
+                  {
+                    newRef = false;
+                  }
+                }
+                if( newRef ) 
+                {
+                  Int insertPoint = newRefs;
+                  //this picture can be added, find appropriate place in list and insert it.
+                  for( Int j = 0; j < newRefs; j++ )
+                  {
+                    if( m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[j] < (offPOC - curPOC) || 
+                        m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[j] > 0 )
+                    {
+                      insertPoint = j;
+                      break;
+                    }
+                  }
+                  Int prev = offPOC - curPOC;
+                  Int prevUsed = (m_GOPListsMvc[viewId][offGOP].m_temporalId <= m_GOPListsMvc[viewId][curGOP].m_temporalId);
+                  for( Int j = insertPoint; j < newRefs+1; j++ )
+                  {
+                    Int newPrev = m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[j];
+                    Int newUsed = m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_usedByCurrPic[j];
+                    m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[j] = prev;
+                    m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_usedByCurrPic[j] = prevUsed;
+                    prevUsed = newUsed;
+                    prev = newPrev;
+                  }
+                  newRefs++;
+                }
+              }
+              if( newRefs >= numPrefRefs )
+              {
+                break;
+              }
+            }
+            m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_numRefPics = newRefs;
+            m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_POC = curPOC;
+            if( m_extraRPSs[viewId] == 0 )
+            {
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_interRPSPrediction = 0;
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_numRefIdc = 0;
+            }
+            else
+            {
+              Int rIdx =  m_iGOPSize + m_extraRPSs[viewId] - 1;
+              Int refPOC = m_GOPListsMvc[viewId][rIdx].m_POC;
+              Int refPics = m_GOPListsMvc[viewId][rIdx].m_numRefPics;
+              Int newIdc = 0;
+              for( Int i = 0; i <= refPics; i++ )
+              {
+                Int deltaPOC = ((i != refPics)? m_GOPListsMvc[viewId][rIdx].m_referencePics[i] : 0);  // check if the reference abs POC is >= 0
+                Int absPOCref = refPOC + deltaPOC;
+                Int refIdc = 0;
+                for( Int j = 0; j < m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_numRefPics; j++ )
+                {
+                  if( (absPOCref - curPOC) == m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_referencePics[j] )
+                  {
+                    if( m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_usedByCurrPic[j] )
+                    {
+                      refIdc = 1;
+                    }
+                    else
+                    {
+                      refIdc = 2;
+                    }
+                  }
+                }
+                m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_refIdc[newIdc] = refIdc;
+                newIdc++;
+              }
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_interRPSPrediction = 1;  
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_numRefIdc = newIdc;
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_deltaRPS = refPOC - m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_POC; 
+              m_GOPListsMvc[viewId][m_iGOPSize+m_extraRPSs[viewId]].m_deltaRIdxMinus1 = 0; 
+            }
+            curGOP = m_iGOPSize + m_extraRPSs[viewId];
+            m_extraRPSs[viewId]++;
+          }
+          numRefs = 0;
+          for( Int i = 0; i < m_GOPListsMvc[viewId][curGOP].m_numRefPics; i++ )
+          {
+            Int absPOC = curPOC + m_GOPListsMvc[viewId][curGOP].m_referencePics[i];
+            if( absPOC >= 0 )
+            {
+              refList[numRefs] = absPOC;
+              numRefs++;
+            }
+          }
+#if !H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+          if(m_maxNumberOfReferencePictures<numRefs)
+          {
+            m_maxNumberOfReferencePictures=numRefs;
+          }
+#endif
+          refList[numRefs] = curPOC;
+          numRefs++;
+#if !H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+          Int nonDisplayed=0;
+          for(Int i=0; i<numRefs; i++) 
+          {
+            if(refList[i]==lastDisp+1) 
+            {
+              lastDisp=refList[i];
+              i=0;
+            }
+          }
+          for(Int i=0; i<numRefs; i++) 
+          {
+            if(refList[i]>lastDisp)
+            {
+              nonDisplayed++;
+            }
+          }
+          if(nonDisplayed>numReorderFramesRequired)
+          {
+            numReorderFramesRequired=nonDisplayed;
+          }
+#endif
+        }
+        checkGOP++;
+      }
+#if !H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+      if (m_numReorderFrames == -1)
+      {
+        m_numReorderFrames = numReorderFramesRequired;
+      }
+#endif
+      xConfirmPara( errorGOP, "Invalid GOP structure given" );
+#if H0566_TLA
+      m_maxTempLayer[viewId] = 1;
+#endif
+      for( Int i = 0; i < m_iGOPSize; i++ ) 
+      {
+#if H0566_TLA
+        if( m_GOPListsMvc[viewId][i].m_temporalId >= m_maxTempLayer[viewId] )
+        {
+          m_maxTempLayer[viewId] = m_GOPListsMvc[viewId][i].m_temporalId + 1;
+        }
+#endif
+        xConfirmPara( m_GOPListsMvc[viewId][i].m_sliceType != 'B' && m_GOPListsMvc[viewId][i].m_sliceType != 'P', "Slice type must be equal to B or P" );
+      }
+
+#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+      for( Int i = 0; i < MAX_TLAYER; i++ )
+      {
+        m_numReorderPics[viewId][i] = 0;
+        m_maxDecPicBuffering[viewId][i] = 0;
+      }
+      for( Int i = 0; i < m_iGOPSize; i++ ) 
+      {
+        if( m_GOPListsMvc[viewId][i].m_numRefPics > m_maxDecPicBuffering[viewId][m_GOPListsMvc[viewId][i].m_temporalId] )
+        {
+          m_maxDecPicBuffering[viewId][m_GOPListsMvc[viewId][i].m_temporalId] = m_GOPListsMvc[viewId][i].m_numRefPics;
+        }
+        Int highestDecodingNumberWithLowerPOC = 0; 
+        for( Int j = 0; j < m_iGOPSize; j++ )
+        {
+          if( m_GOPListsMvc[viewId][j].m_POC <= m_GOPListsMvc[viewId][i].m_POC )
+          {
+            highestDecodingNumberWithLowerPOC = j;
+          }
+        }
+        Int numReorder = 0;
+        for( Int j = 0; j < highestDecodingNumberWithLowerPOC; j++ )
+        {
+          if( m_GOPListsMvc[viewId][j].m_temporalId <= m_GOPListsMvc[viewId][i].m_temporalId && 
+              m_GOPListsMvc[viewId][j].m_POC        >  m_GOPListsMvc[viewId][i].m_POC )
+          {
+            numReorder++;
+          }
+        }    
+        if( numReorder > m_numReorderPics[viewId][m_GOPListsMvc[viewId][i].m_temporalId] )
+        {
+          m_numReorderPics[viewId][m_GOPListsMvc[viewId][i].m_temporalId] = numReorder;
+        }
+      }
+      for( Int i = 0; i < MAX_TLAYER-1; i++ ) 
+      {
+        // a lower layer can not have higher value of m_numReorderPics than a higher layer
+        if( m_numReorderPics[viewId][i+1] < m_numReorderPics[viewId][i] )
+        {
+          m_numReorderPics[viewId][i+1] = m_numReorderPics[viewId][i];
+        }
+        // the value of num_reorder_pics[ i ] shall be in the range of 0 to max_dec_pic_buffering[ i ], inclusive
+        if( m_numReorderPics[viewId][i] > m_maxDecPicBuffering[viewId][i] )
+        {
+          m_maxDecPicBuffering[viewId][i] = m_numReorderPics[viewId][i];
+        }
+        // a lower layer can not have higher value of m_uiMaxDecPicBuffering than a higher layer
+        if( m_maxDecPicBuffering[viewId][i+1] < m_maxDecPicBuffering[viewId][i] )
+        {
+          m_maxDecPicBuffering[viewId][i+1] = m_maxDecPicBuffering[viewId][i];
+        }
+      }
+      // the value of num_reorder_pics[ i ] shall be in the range of 0 to max_dec_pic_buffering[ i ], inclusive
+      if( m_numReorderPics[viewId][MAX_TLAYER-1] > m_maxDecPicBuffering[viewId][MAX_TLAYER-1] )
+      {
+        m_maxDecPicBuffering[viewId][MAX_TLAYER-1] = m_numReorderPics[viewId][MAX_TLAYER-1];
+      }
+#endif
+
+#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+      xConfirmPara( m_bUseLComb == false && m_numReorderPics[viewId][MAX_TLAYER-1] != 0, "ListCombination can only be 0 in low delay coding (more precisely when L0 and L1 are identical)" );  // Note however this is not the full necessary condition as ref_pic_list_combination_flag can only be 0 if L0 == L1.
+#else
+      xConfirmPara( m_bUseLComb==false && m_numReorderFrames!=0, "ListCombination can only be 0 in low delay coding (more precisely when L0 and L1 are identical)" );  // Note however this is not the full necessary condition as ref_pic_list_combination_flag can only be 0 if L0 == L1.
+      xConfirmPara( m_numReorderFrames < numReorderFramesRequired, "For the used GOP the encoder requires more pictures for reordering than specified in MaxNumberOfReorderPictures" );
+#endif
+    }
+  }
+#undef xConfirmPara
+  if( check_failed )
   {
     exit(EXIT_FAILURE);
@@ -801,11 +1440,4 @@
   xCleanUpVector( m_pchReconFileList,       (char*)0 );
   xCleanUpVector( m_pchDepthReconFileList,  (char*)0 );
-
-#if HHI_VSO
-  if ( m_bUseVSO)
-  {
-    xCleanUpVector( m_pchERRefFileList,       (char*)0 );
-  }
-#endif
 }
 
@@ -817,31 +1449,14 @@
   g_uiMaxCUWidth  = m_uiMaxCUWidth;
   g_uiMaxCUHeight = m_uiMaxCUHeight;
-
+  
   // compute actual CU depth with respect to config depth and max transform size
   g_uiAddCUDepth  = 0;
   while( (m_uiMaxCUWidth>>m_uiMaxCUDepth) > ( 1 << ( m_uiQuadtreeTULog2MinSize + g_uiAddCUDepth )  ) ) g_uiAddCUDepth++;
-
+  
   m_uiMaxCUDepth += g_uiAddCUDepth;
   g_uiAddCUDepth++;
   g_uiMaxCUDepth = m_uiMaxCUDepth;
-
+  
   // set internal bit-depth and constants
-#if ENABLE_IBDI
-  if ((int)m_uiBitIncrement != -1)
-  {
-    g_uiBitDepth = m_uiInputBitDepth;
-    g_uiBitIncrement = m_uiBitIncrement;
-    m_uiInternalBitDepth = g_uiBitDepth + g_uiBitIncrement;
-  }
-  else
-  {
-    g_uiBitDepth = min(8u, m_uiInputBitDepth);
-    if (m_uiInternalBitDepth == 0) {
-      /* default increement = 2 */
-      m_uiInternalBitDepth = 2 + g_uiBitDepth;
-    }
-    g_uiBitIncrement = m_uiInternalBitDepth - g_uiBitDepth;
-  }
-#else
 #if FULL_NBIT
   g_uiBitDepth = m_uiInternalBitDepth;
@@ -851,11 +1466,11 @@
   g_uiBitIncrement = m_uiInternalBitDepth - g_uiBitDepth;
 #endif
-#endif
+
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-  g_dDeltaDCsQuantOffset = Double(g_uiBitIncrement) -  2.0;
+  g_iDeltaDCsQuantOffset = g_uiBitIncrement - 2;
 #endif
 
   g_uiBASE_MAX     = ((1<<(g_uiBitDepth))-1);
-
+  
 #if IBDI_NOCLIP_RANGE
   g_uiIBDI_MAX     = g_uiBASE_MAX << g_uiBitIncrement;
@@ -863,9 +1478,12 @@
   g_uiIBDI_MAX     = ((1<<(g_uiBitDepth+g_uiBitIncrement))-1);
 #endif
-
+  
   if (m_uiOutputBitDepth == 0)
   {
     m_uiOutputBitDepth = m_uiInternalBitDepth;
   }
+
+  g_uiPCMBitDepthLuma = m_uiPCMBitDepthLuma = ((m_bPCMInputBitDepthFlag)? m_uiInputBitDepth : m_uiInternalBitDepth);
+  g_uiPCMBitDepthChroma = ((m_bPCMInputBitDepthFlag)? m_uiInputBitDepth : m_uiInternalBitDepth);
 }
 
@@ -873,23 +1491,32 @@
 {
   printf("\n");
-  for( Int iCounter = 0; iCounter<m_iNumberOfViews; iCounter++)
-  {
-    printf("Input          File %i        : %s\n", iCounter, m_pchInputFileList[iCounter]);
-  }
-  for( Int iCounter = 0; iCounter < (Int)m_pchDepthInputFileList.size(); iCounter++)
-  {
-    printf("DepthInput     File %i        : %s\n", iCounter, m_pchDepthInputFileList[iCounter]);
-  }
-  printf("Bitstream      File          : %s\n", m_pchBitstreamFile      );
-  for( Int iCounter = 0; iCounter<m_iNumberOfViews; iCounter++)
-  {
-    printf("Reconstruction File %i        : %s\n", iCounter, m_pchReconFileList[iCounter]);
-  }
-
-  for( Int iCounter = 0; iCounter<(Int)m_pchDepthReconFileList.size(); iCounter++)
-  {
-    printf("Reconstruction Depth File %i  : %s\n", iCounter, m_pchDepthReconFileList[iCounter]);
-  }
+  for( Int iCounter = 0; iCounter< m_iNumberOfViews; iCounter++)
+  {
+    printf("Texture Input File %i            : %s\n", iCounter, m_pchInputFileList[iCounter]);
+  }
+  if( m_bUsingDepthMaps )
+  {
+    for( Int iCounter = 0; iCounter < m_iNumberOfViews; iCounter++)
+    {
+      printf("Depth Input File %i              : %s\n", iCounter, m_pchDepthInputFileList[iCounter]);
+    }
+  }
+  printf("Bitstream File                  : %s\n", m_pchBitstreamFile      );
+  for( Int iCounter = 0; iCounter< m_iNumberOfViews; iCounter++)
+  {
+    printf("Texture Reconstruction File %i   : %s\n", iCounter, m_pchReconFileList[iCounter]);
+  }
+  if( m_bUsingDepthMaps )
+  {
+    for( Int iCounter = 0; iCounter< m_iNumberOfViews; iCounter++)
+    {
+      printf("Depth Reconstruction File %i     : %s\n", iCounter, m_pchDepthReconFileList[iCounter]);
+    }
+  }
+#if PIC_CROPPING
+  printf("Real     Format              : %dx%d %dHz\n", m_iSourceWidth - m_cropLeft - m_cropRight, m_iSourceHeight - m_cropTop - m_cropBottom, m_iFrameRate );
+#else
   printf("Real     Format              : %dx%d %dHz\n", m_iSourceWidth - m_aiPad[0], m_iSourceHeight-m_aiPad[1], m_iFrameRate );
+#endif
   printf("Internal Format              : %dx%d %dHz\n", m_iSourceWidth, m_iSourceHeight, m_iFrameRate );
   printf("Frame index                  : %u - %d (%d frames)\n", m_FrameSkip, m_FrameSkip+m_iFrameToBeEncoded-1, m_iFrameToBeEncoded );
@@ -898,34 +1525,28 @@
   printf("Max RQT depth inter          : %d\n", m_uiQuadtreeTUMaxDepthInter);
   printf("Max RQT depth intra          : %d\n", m_uiQuadtreeTUMaxDepthIntra);
+  printf("Min PCM size                 : %d\n", 1 << m_uiPCMLog2MinSize);
   printf("Motion search range          : %d\n", m_iSearchRange );
-#if DCM_DECODING_REFRESH
+  printf("Intra period                 : %d\n", m_iIntraPeriod );
   printf("Decoding refresh type        : %d\n", m_iDecodingRefreshType );
-#endif
-  printf("QP                           : %5.2f\n", m_adQP[0] );
-  printf("QP Depth                     : %5.2f\n", m_adQP[ m_adQP.size()  < 2 ? 0 : 1] );
-  printf("Coded Picture Store Size     : %d\n", m_uiCodedPictureStoreSize);
+  printf("QP Texture                   : %5.2f\n", m_adQP[0] );
+  if( m_bUsingDepthMaps )
+  {
+    printf("QP Depth                     : %5.2f\n", m_adQP[ m_adQP.size()  < 2 ? 0 : 1] );
+  }
+  printf("Max dQP signaling depth      : %d\n", m_iMaxCuDQPDepth);
+
+  printf("Chroma Qp Offset             : %d\n", m_iChromaQpOffset   );
+  printf("Chroma Qp Offset 2nd         : %d\n", m_iChromaQpOffset2nd);
+
+  printf("QP adaptation                : %d (range=%d)\n", m_bUseAdaptiveQP, (m_bUseAdaptiveQP ? m_iQPAdaptationRange : 0) );
   printf("GOP size                     : %d\n", m_iGOPSize );
-  printf("Rate GOP size                : %d\n", m_iRateGOPSize );
   printf("Internal bit depth           : %d\n", m_uiInternalBitDepth );
-
-  if ( m_iSymbolMode == 0 )
-  {
-    printf("Entropy coder                : VLC\n");
-  }
-  else if( m_iSymbolMode == 1 )
-  {
-    printf("Entropy coder                : CABAC\n");
-  }
-  else if( m_iSymbolMode == 2 )
-  {
-    printf("Entropy coder                : PIPE\n");
-  }
-  else
-  {
-    assert(0);
-  }
-
-  printf("GOP Format String            : %s\n", m_cInputFormatString.c_str() );
-  printf("Loop Filter Disabled         : %d %d\n", m_abLoopFilterDisable[0] ? 1 : 0,  m_abLoopFilterDisable[1] ? 1 : 0 );
+  printf("PCM sample bit depth         : %d\n", m_uiPCMBitDepthLuma );
+  if((m_uiMaxCUWidth >> m_uiMaxCUDepth) == 4)
+  {
+    printf("DisableInter4x4              : %d\n", m_bDisInter4x4);  
+  }
+
+printf("Loop Filter Disabled         : %d %d\n", m_abLoopFilterDisable[0] ? 1 : 0,  m_abLoopFilterDisable[1] ? 1 : 0 );
   printf("Coded Camera Param. Precision: %d\n", m_iCodedCamParPrecision);
 
@@ -943,9 +1564,17 @@
   }
 #endif
-
+#if HHI_INTERVIEW_SKIP
+    printf("InterView Skip:              : %d\n",    m_bInterViewSkip ? 1:0 );
+    printf("InterView Skip Lambda Scale  : %f\n",    m_dInterViewSkipLambdaScale );
+#endif
 
   printf("\n");
-
-  printf("TOOL CFG GENERAL: ");
+  
+  printf("TOOL CFG General: ");  
+#if LCU_SYNTAX_ALF
+  printf("ALFMNF:%d ", m_iALFMaxNumberFilters);
+  printf("ALFInSlice:%d ", m_bALFParamInSlice);
+  printf("ALFPicEnc:%d ", m_bALFPicBasedEncode);
+#endif
   printf("IBD:%d ", !!g_uiBitIncrement);
   printf("HAD:%d ", m_bUseHADME           );
@@ -953,33 +1582,66 @@
   printf("SQP:%d ", m_uiDeltaQpRD         );
   printf("ASR:%d ", m_bUseASR             );
+#if !PIC_CROPPING
   printf("PAD:%d ", m_bUsePAD             );
-  printf("LDC:%d ", m_bUseLDC             );
-#if DCM_COMB_LIST
+#endif
   printf("LComb:%d ", m_bUseLComb         );
   printf("LCMod:%d ", m_bLCMod         );
-#endif
   printf("FEN:%d ", m_bUseFastEnc         );
+  printf("ECU:%d ", m_bUseEarlyCU         );
+#if FAST_DECISION_FOR_MRG_RD_COST
+  printf("FDM:%d ", m_useFastDecisionForMerge );
+#endif
+  printf("CFM:%d ", m_bUseCbfFastMode         );
   printf("RQT:%d ", 1     );
-  printf("MRG:%d ", m_bUseMRG             ); // SOPH: Merge Mode
-#if LM_CHROMA
-  printf("LMC:%d ", m_bUseLMChroma        );
-#endif
-#if HHI_RMP_SWITCH
-  printf("RMP:%d ", m_bUseRMP);
-#endif
-  printf("Slice:%d ",m_iSliceMode);
+  printf("LMC:%d ", m_bUseLMChroma        ); 
+  printf("Slice: G=%d M=%d ", m_iSliceGranularity, m_iSliceMode);
   if (m_iSliceMode!=0)
   {
-    printf("(%d) ", m_iSliceArgument);
-  }
-  printf("EntropySlice:%d ",m_iEntropySliceMode);
+    printf("A=%d ", m_iSliceArgument);
+  }
+  printf("EntropySlice: M=%d ",m_iEntropySliceMode);
   if (m_iEntropySliceMode!=0)
   {
-    printf("(%d) ", m_iEntropySliceArgument);
-  }
-#if CONSTRAINED_INTRA_PRED
+    printf("A=%d ", m_iEntropySliceArgument);
+  }
   printf("CIP:%d ", m_bUseConstrainedIntraPred);
-#endif
-#if MTK_SAO
+#if BURST_IPCM
+  printf("PCM:%d ", (m_usePCM && (1<<m_uiPCMLog2MinSize) <= m_uiMaxCUWidth)? 1 : 0);
+#else
+  printf("PCM:%d ", ((1<<m_uiPCMLog2MinSize) <= m_uiMaxCUWidth)? 1 : 0);
+#endif
+#if SAO_UNIT_INTERLEAVING
+  printf("SAOInterleaving:%d ", (m_saoInterleavingFlag)?(1):(0));
+#endif
+#if LOSSLESS_CODING
+  printf("LosslessCuEnabled:%d ", (m_useLossless)? 1:0 );
+#endif  
+  printf("WPP:%d ", (Int)m_bUseWeightPred);
+  printf("WPB:%d ", m_uiBiPredIdc);
+#if !REMOVE_TILE_DEPENDENCE
+  printf("TileBoundaryIndependence:%d ", m_iTileBoundaryIndependenceIdr ); 
+#endif
+  printf("TileLocationInSliceHdr:%d ", m_iTileLocationInSliceHeaderFlag);
+  printf("TileMarker:%d", m_iTileMarkerFlag);
+  if (m_iTileMarkerFlag)
+  {
+    printf("[%d] ", m_iMaxTileMarkerEntryPoints);
+  }
+  else
+  {
+    printf(" ");
+  }
+  printf(" WaveFrontSynchro:%d WaveFrontFlush:%d WaveFrontSubstreams:%d",
+          m_iWaveFrontSynchro, m_iWaveFrontFlush, m_iWaveFrontSubstreams);
+  printf(" ScalingList:%d ", m_useScalingListId );
+
+  printf("TMVP:%d ", m_enableTMVP     );
+
+#if ADAPTIVE_QP_SELECTION
+  printf("AQpS:%d", m_bUseAdaptQpSelect   );
+#endif
+
+#if MULTIBITS_DATA_HIDING
+  printf(" SignBitHidingFlag:%d SignBitHidingThreshold:%d", m_signHideFlag, m_signHidingThreshold);
 #endif
   printf("\n");
@@ -1003,6 +1665,6 @@
   printf("MVI:%d ", m_bUseMVI ? 1 : 0 );
 #endif
-  printf("\n");
-
+  printf("\n\n");
+  
   fflush(stdout);
 }
